/* Scan Bison Skeletons.                                       -*- C -*-
   Copyright (C) 2001, 2002  Free Software Foundation, Inc.

   This file is part of Bison, the GNU Compiler Compiler.

   Bison is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   Bison is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Bison; see the file COPYING.  If not, write to the Free
   Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.  */

%option nodefault noyywrap nounput never-interactive
%option prefix="skel_" outfile="lex.yy.c"

%{
#include "system.h"
#include "error.h"
#include "getargs.h"
#include "files.h"
int skel_lex (void);
static int yylineno = 1;
static char *yyoutname = NULL;
%}
%%
  /* This is an approximation, but we don't need more. */
^"#output \""[^\"]+\"\n        {
     yytext[yyleng - 2] = '\0';
     XFREE (yyoutname);
     yyoutname = xstrdup (yytext + strlen ("#output \""));
     yyout = xfopen (yyoutname, "w");
     yylineno = 1;
   }

"@<:@"           fputc ('[', yyout);
"@:>@"           fputc (']', yyout);

"__oline__"      fprintf (yyout, "%d", yylineno+1);
"__ofile__"      fprintf (yyout, "%s", yyoutname);
[^@_\n]+         ECHO;
\n+              yylineno += yyleng; ECHO;
.                ECHO;

<<EOF>>          xfclose (yyout); free (yyoutname); return EOF;
%%

/*------------------------.
| Scan a Bison skeleton.  |
`------------------------*/

void scan_skel (FILE *);

void
scan_skel (FILE *in)
{
  skel_in = in;
  skel_lex ();

  /* Reclaim Flex's buffers.  */
  yy_delete_buffer (YY_CURRENT_BUFFER);
}
